package com.example.clickclick;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.pm.ActivityInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.StrictMode;
import android.widget.Toast;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;

public class MainActivity extends Activity implements OnItemSelectedListener {

	private EditText entrada;
	private String devuelve = "";
	private String paisorigen, paisdestino;
	private String monedaorigen, monedadestino;
	private String cabezahttp, mediohttp, finalhttp;
	private TextView salida;
	private ImageView escudo1, escudo2;
	private Float resultadocambio;
	private Spinner spinnerorigen, spinnerdestino;

	@Override
	public void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);

		setContentView(R.layout.activity_main);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

		entrada = (EditText) findViewById(R.id.editText01);
		salida = (TextView) findViewById(R.id.textView01);
		escudo1 = (ImageView) findViewById(R.id.imageView1);
		escudo2 = (ImageView) findViewById(R.id.imageView2);
		spinnerorigen = (Spinner) findViewById(R.id.spinner1);
		spinnerdestino = (Spinner) findViewById(R.id.spinner2);

		StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder()
				.permitNetwork().build());

		spinnerorigen.setOnItemSelectedListener(new OnItemSelectedListener() {
			@Override
			public void onItemSelected(AdapterView<?> arg0, View arg1,
					int arg2, long arg3) {

				paisorigen = String.valueOf(spinnerorigen.getSelectedItem());

				int fin = paisorigen.indexOf(" ", 5);

				monedaorigen = paisorigen.substring(0, 3);
				paisorigen = paisorigen.substring(4, fin);

				paisorigen = paisorigen.toLowerCase();

				String recurso = "drawable";

				int res_imagen = getResources().getIdentifier(paisorigen,
						recurso, getPackageName());

				escudo1.setImageResource(res_imagen);

			}

			@Override
			public void onNothingSelected(AdapterView<?> arg0) {
			}
		});

		spinnerdestino.setOnItemSelectedListener(new OnItemSelectedListener() {
			@Override
			public void onItemSelected(AdapterView<?> arg0, View arg1,
					int arg2, long arg3) {

				paisdestino = String.valueOf(spinnerdestino.getSelectedItem());

				int fin1 = paisdestino.indexOf(" ", 5);

				monedadestino = paisdestino.substring(0, 3);
				paisdestino = paisdestino.substring(4, fin1);

				paisdestino = paisdestino.toLowerCase();

				String recurso = "drawable";

				int res_imagen = getResources().getIdentifier(paisdestino,
						recurso, getPackageName());

				escudo2.setImageResource(res_imagen);

			}

			@Override
			public void onNothingSelected(AdapterView<?> arg0) {
			}
		});
	}

	@Override
	public void onItemSelected(AdapterView<?> adapter, View view, int position,
			long id) {
		// Aqu se codifica la lgica que se ejecutar al seleccionar un
		// elemento del Spinner.

	}

	@Override
	public void onNothingSelected(AdapterView<?> adapter) {

	}

	public void buscar(View view) {

		String palabras = entrada.getText().toString();
		salida.append(palabras);
		new BuscarGoogle().execute(palabras);

	}

	public void borrardatos(View view) {

		entrada.setText("");
		salida.setText("");
	}

	String resultadosGoogle(String palabras) throws Exception {

		String pagina = "";
		devuelve = "";

		URL url = new URL(
				"http://www.webservicex.net/CurrencyConvertor.asmx/ConversionRate?FromCurrency="
						+ monedaorigen + "&ToCurrency=" + monedadestino);

		HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
		conexion.setRequestProperty("User-Agent",
				"Mozilla/5.0 (Windows NT 6.1)");

		if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					conexion.getInputStream()));
			String linea = reader.readLine();
			while (linea != null) {
				pagina += linea;
				linea = reader.readLine();

			}

			reader.close();

			int ini = pagina.indexOf("X.NET/");

			if (ini != -1) {

				int inif = pagina.indexOf("<", ini);

				devuelve = pagina.substring(ini + 8, inif);

				resultadocambio = Float.parseFloat(devuelve);

				resultadocambio = (Float.parseFloat(entrada.getText()
						.toString())) * resultadocambio;
				devuelve = String.format("%.2f", resultadocambio);

			} else {
				devuelve = "no encontrado";
			}
		} else {
			salida.append("ERROR: " + conexion.getResponseMessage() + "\n");
		}

		conexion.disconnect();

		return devuelve;

	}

	class BuscarGoogle extends AsyncTask<String, Void, String> {

		private ProgressDialog progreso;

		@Override
		protected void onPreExecute() {
			progreso = new ProgressDialog(MainActivity.this);
			progreso.setProgressStyle(ProgressDialog.STYLE_SPINNER);
			progreso.setMessage("Accediendo a Currency Convertor...");
			progreso.setCancelable(false);
			progreso.show();

		}

		@Override
		protected String doInBackground(String... palabras) {

			try {
				String s = resultadosGoogle(palabras[0]);
				Log.e("HTTP2", s);
				return s;

			} catch (Exception e) {
				cancel(true);
				Log.e("HTTP", e.getMessage(), e);
				return null;

			}

		}

		@Override
		protected void onPostExecute(String res) {

			progreso.dismiss();
			// salida.append(res + "\n");
			salida.setText(res + "\n");
		}

		@Override
		protected void onCancelled() {

			progreso.dismiss();
			salida.append("Error al conectar\n");

		}

	}

}
